<template>
	<form @submit="submitImage">
		<p class="text-center mb-2 font-bold">Select an image</p>
		<input class="mt-2" type="file" @change="fileChange" accept="image/png" />
        <p class="text-red-500">{{ errorInput }}</p>
	</form>
	<div>
        <img class="mx-auto" id="img" height="400" v-show="imgSrc" :src="imgSrc" alt="" />
    </div>
	<Result :result="result || warningMessage" />
</template>

<script>
import { ref } from '@vue/reactivity';
import { getDataFromUpload } from '../utils/function';
import { useStore } from 'vuex';
import { computed, onMounted } from '@vue/runtime-core';
import { SET_RESULT_IMG, SET_WARNING_MESSAGE_IMG } from '../store/mutations';

import Result from "../components/Result.vue";

export default {
    name: "QRCOdeImage",
    components: {
        Result
    },
    setup() {
        const store = useStore();

        const errorInput = ref("");

        const result = computed(() => store.state.result.fromImage.result);
        const warningMessage = computed(() => store.state.result.fromImage.warningMessage)

        const fileSelected = ref(null);
		const imgSrc = ref(null);

        const decodeImage = (src) => {
			getDataFromUpload(src, (error, result) => {
                if (error) {
                    store.commit(SET_RESULT_IMG, error)
                } else {
                    store.commit(SET_WARNING_MESSAGE_IMG, result)
                }
            });
		};

		const fileChange = (e) => {
            store.commit(SET_RESULT_IMG, null);
            store.commit(SET_WARNING_MESSAGE_IMG, null);
            imgSrc.value = null;

            errorInput.value = null;
			fileSelected.value = e.target.files[0];
            
            if (/(\.png)$/.test(e.target.files[0].name)) {
                const fileReader = new FileReader();
                fileReader.addEventListener("load", () => {
                    imgSrc.value = fileReader.result;
                    decodeImage(fileReader.result);
                });
                fileReader.readAsDataURL(e.target.files[0]);
                
            } else {
                errorInput.value = "Image must be png format.";
            }
			
		};

        onMounted(() => {
            store.commit(SET_RESULT_IMG, null);
            store.commit(SET_WARNING_MESSAGE_IMG, null);
        })

        return {
            errorInput,
            fileSelected,
            imgSrc,
            fileChange,
            result, 
            warningMessage
        }
    }
};
</script>

<style>
</style>